<template>
  <div v-loading="loading">
    <CDataTable
      hover
      :items="data"
      :fields="FIELDS"
      class="table-wrapper"
    >
      <template #control="{item}">
        <td>
          <app-control-button
            :id="item.id"
            :color="COLOR_SUCCESS_CONTROL_BUTTON"
            :variant="VARIANT_CONTROL_BUTTON"
            :control-label="'On all'"
            @set-control="onControl"
          />

          <app-control-button
            :id="item.id"
            :color="COLOR_DANGER_CONTROL_BUTTON"
            :variant="VARIANT_CONTROL_BUTTON"
            :control-label="'Off all'"
            @set-control="offControl"
          />
        </td>
      </template>

      <template #zone="{item}">
        <td>
          {{ item.zone ? item.zone.name : '' }}
        </td>
      </template>

      <template #description="{item}">
        <td>
          {{ item.description ? item.description : '' }}
        </td>
      </template>

      <template #status="{item}">
        <td>
          <span :class="`badge badge-${item.status === 1 ? 'success' : 'danger'}`">
            {{ item.status === 1 ? 'ON' : 'OFF' }}
          </span>
        </td>
      </template>

      <template #action="{ item }">
        <td class="white-space-nowrap">
          <CButton size="sm" color="primary" @click="onShowDetail(item.id)">
            <font-awesome-icon :icon="['fas', 'pencil-alt']" />
          </CButton>
          &nbsp;
          <CButton size="sm" color="danger" @click="onDelete(item.id)">
            <font-awesome-icon :icon="['fas', 'trash-alt']" />
          </CButton>
        </td>
      </template>
    </CDataTable>
  </div>
</template>

<style lang="scss" scoped>
  .table-wrapper {
    /deep/ {
      width: 100%;
      border-bottom: 1px solid #d8dbe0;
      margin-bottom: 0;
      thead {
          tr {
            th {
              text-align: center;
              &.id{
                width:60px;
              }
              &.name{
                width:150px;
              }
              &.zone{
                width:150px;
              }
              &.desc{
                width:200px;
              }
              &.status{
                width:100px;
              }
              &.control{
                width:100px;
              }
              &.action{
                width:60px;
              }
            }
          }
        }
      & td{
        padding: 0 12px;
        vertical-align: 0;
        text-align: center;
      }
    }
  }
</style>
<script>
import AppControlButton from '~/components/atoms/AppControlButton'

const EVENT_DELETE = 'delete'
const EVENT_SHOW_DETAIL = 'show-detail'
const EVENT_ON_CONTROL = 'on-control'
const EVENT_OFF_CONTROL = 'off-control'
const COLOR_SUCCESS_CONTROL_BUTTON = 'success'
const COLOR_DANGER_CONTROL_BUTTON = 'danger'
const VARIANT_CONTROL_BUTTON = 'ghost'

export const FIELDS = [
  { key: 'id', label: 'No.', _classes: 'id' },
  { key: 'name', _classes: 'name' },
  { key: 'zone', label: 'Zone', _classes: 'zone' },
  { key: 'description', _classes: 'desc' },
  { key: 'status', _classes: 'status' },
  { key: 'control', sorter: false, _classes: 'control' },
  { key: 'action', label: 'Action', sorter: false, _classes: 'action' }
]
export default {
  components: {
    AppControlButton
  },
  props: {
    /**
     * Zone list
     */
    data: {
      type: Array,
      default: () => []
    },

    /**
     * Loading status
     */
    loading: {
      type: Boolean,
      default: false
    }
  },

  data () {
    return {
      COLOR_SUCCESS_CONTROL_BUTTON,
      COLOR_DANGER_CONTROL_BUTTON,
      VARIANT_CONTROL_BUTTON,
      isOn: false
    }
  },
  computed: {
    /**
     * Get FIELDS of header table
     *
     * @return {array} FIELDS of header table
     */
    FIELDS () {
      return FIELDS
    }
  },

  methods: {
    /**
     * Event show user detail modal
     *
     * @param {string} user - User
     */
    onShowDetail (id) {
      this.$emit(EVENT_SHOW_DETAIL, id)
    },

    /**
     * Delete user
     *
     * @param {string} id - User id
     */
    onDelete (id) {
      this.$emit(EVENT_DELETE, id)
    },

    onControl (id) {
      this.isOn = true
      this.$emit(EVENT_ON_CONTROL, id, this.isOn)
    },

    offControl (id) {
      this.$emit(EVENT_OFF_CONTROL, id)
    }
  }
}
</script>
